#ifndef IOMANIP_H
#define IOMANIP_H

template <class T> class IMANIP {
    istream& (*_f)(istream&, T);
    T _a;
public:
    IMANIP(istream& (*f)(istream&, T), T a) : _f(f), _a(a) {}
    friend istream& operator>>(istream& i, const IMANIP<T>& m);
};

template <class T> class OMANIP {
    ostream& (*_f)(ostream&, T);
    T _a;
public:
    OMANIP(ostream& (*f)(ostream&, T), T a) : _f(f), _a(a) {}
    friend ostream& operator<<(ostream& o, OMANIP<T> m);
};

#endif
