#include "General.h"

ostream&
_encode(ostream& s, unsigned long n) {
  n = htonl(n);
  s.write((char*)(&n), sizeof(unsigned long));
  return s;
}

OMANIP<unsigned long>
encode(unsigned long n) {
  return OMANIP<unsigned long>(&_encode, n);
}

istream&
_decode(istream& s, unsigned long& n) {
  s.read((char*)(&n), sizeof(unsigned long));
  n = ntohl(n);
  return s;
}

IMANIP<unsigned long&>
decode(unsigned long& n) {
  return IMANIP<unsigned long&>(&_decode, n);
}

ostream&
_encode(ostream& s, int n) {
  n = htonl(n);
  s.write((char*)(&n), sizeof(int));
  return s;
}

OMANIP<int>
encode(int n) {
  return OMANIP<int>(&_encode, n);
}

istream&
_decode(istream& s, int& n) {
  s.read((char*)(&n), sizeof(int));
  n = ntohl(n);
  return s;
}

IMANIP<int&>
decode(int& n) {
  return IMANIP<int&>(&_decode, n);
}
