#ifndef IPC_H
#define IPC_H

#include "General.h"
#include "MTCP.h"

class IPCM {
private:
  static ostrstream* s;
public:
  static void Reset();
  static ostrstream& S() { return (*s); }
  static void Issue(int);
  static istrstream* Accept(int);
};

class IPC {
private:
  static pid_t pid;
  static int fd;
  static unsigned long server_port;
public:
  static void Init(CALLBACK_INT);
  static int ObtainConnection(int);
  static pid_t PID() { return (pid); }

  /* Messaging API */
private:
  static ostrstream* s;
public:
  static void Reset();
  static ostrstream& S() { return (*s); }
  static void Issue();
  static istrstream* Accept();
};

#endif
